# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc返利规则商品客户范围查询验证,2271,2271-25,sit,bs
主数据平台:后台运营系统返利规则商品客户范围查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)

# 获取返利规则信息
rebate_id = result["data"]["list"][rebate_random]["rebateid"]

# 第二步获取返利规则对应的客户范围
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url13")
request_body = commonFuc().get_business_data(module, "payload13", rebate_id)

"""
 场景: 验证返利规则是否可以正常查看对应的客户范围
 用例名称：返利规则商品客户范围查询验证
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict13")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

# 获取返利规则对应的客户数量
total = result["data"]["total"]
print(total)
# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库查询返利规则包含的客户数量
sql = "SELECT t.rebateUserId FROM `cmdc-order`.tc_rebate_user t WHERE rebateId = {}".format(rebate_id)
result = {"total": len(mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql))}
print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict11_1", total)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

